"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path = require("path");

var _utils = require("@mdfjs/utils");

var _inject = _interopRequireDefault(require("./inject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file 集成业务框架 - dva
 * @todo 支持 useSelector 和 immr，并且提供 request api
 */
function _default(api) {
  let unwatch;
  api.onCodeGenerate(function () {
    const paths = api.paths,
          Mustache = api.Mustache; // 不要解析 main 字段，不然 typescript 会报错，这里应该读一下 package.json

    const dvaPath = require.resolve('dva').replace('/dist/index.js', '');

    (0, _inject.default)(api, dvaPath);
    unwatch = (0, _utils.watch)({
      path: (0, _path.resolve)('./src/models'),
      keys: ['add', 'unlink', 'addDir', 'unlinkDir', 'change'],
      onChange: function onChange() {
        (0, _inject.default)(api, dvaPath);
      }
    });
    const exportTpl = api.getFile((0, _path.join)(__dirname, './exports.tpl'));
    const exportContent = Mustache.render(exportTpl, {
      dvaPath
    });
    api.writeFile(`${paths.absTmpPath}/plugins-dva/export.ts`, (0, _utils.prettierFormat)(exportContent));
  });
  api.addRuntimeExports(() => ({
    all: true,
    source: `${api.paths.absTmpPath}/plugins-dva/export`
  })); // 进程结束前注销，这里可以优化

  api.onProcessExit(function () {
    (0, _utils.chalkPrints)([['unwatch:', 'yellow'], ' dva src/models']);
    unwatch && unwatch();
  });
}